function [paths,probs] = highprobpaths_m(probmat,minprob,start,stop)
% could probably write as java or mex for dramatically better performance

% if nargin < 5
% 	currentprob = 1;
% 	depth = 1;
% end

% [pmto,pmfrom,pmval] = find(probmat);
% nedge = numel(pmto);
nvert = size(probmat,1);

nodelinkstopaths = cell(nvert,1);
started = false(nvert,1); % use to detect cycles
unfinished = true(nvert,1);

pathnode = nan(nvert,1);
pathprob = zeros(nvert,1);
pathvert = zeros(nvert,1);
disttoend = zeros(nvert,1);

npnodes = 1;
pathnode(1) = 0;
pathprob(1) = 1;
pathvert(1) = stop;
disttoend(1) = 0;
nodelinkstopaths{stop} = 1;
started(stop) = true;
unfinished(stop) = false;

findpathsthrough(start);

npaths = numel(nodelinkstopaths{start});

probs = pathprob(nodelinkstopaths{start});
paths = cell(npaths,1);
for p = 1:npaths
	n = nodelinkstopaths{start}(p);
	paths{p} = zeros(disttoend(n)-1,1);
	for k = 1:disttoend(n)-1
		n = pathnode(n);
		paths{p}(k) = pathvert(n);
	end
end

	function findpathsthrough(curr)
		if started(curr)
			error('found cycle in graph - graph must be acyclic')
		end
		started(curr) = true;
		
		[nextverts,~,tprobs] = find(probmat(:,curr));
		nbranch = numel(nextverts);
		j1 = 0;
		for i = 1:nbranch
			if unfinished(nextverts(i))
				findpathsthrough(nextverts(i));
			end
			for j = 1:numel(nodelinkstopaths{nextverts(i)})
				pnode = nodelinkstopaths{nextverts(i)}(j);
				nprob = pathprob(pnode) * tprobs(i);
				if nprob > minprob
					npnodes = npnodes+1;
					pathnode(npnodes) = pnode;
					pathprob(npnodes) = pathprob(pnode) * tprobs(i);
					pathvert(npnodes) = curr;
					disttoend(npnodes) = disttoend(pnode)+1;
					j1 = j1 + 1;
					nodelinkstopaths{curr}(j1) = npnodes;
				end
			end
		end
		
		unfinished(curr) = false;
	end
end